<?php
// File: $Id: admin.php,v 1.0 2002/09/11 10:36:37 CyberOto Exp $ $Name:  $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Yassen Yotov
// Purpose of file: Admin interface
// ----------------------------------------------------------------------
function PostWrap_adminapi_updateLinks($var)
	{
		$output = new pnHTML();
		// Security check - important to do this as early as possible to avoid
		// potential security holes or just too much wasted processing
		if (!pnSecAuthAction(0, 'PostWrap::', '::', ACCESS_ADMIN))
		{
			$output->Text(_MODIFYLINKSSNOAUTH);
			return $output->GetOutput();
		}
		
		list($default_size, $allow_local_only, $use_buffering, $use_compression, $no_user_entry, $security, $reg_user_only, $open_direct, $use_fixed_title, $auto_resize, $vsize) = pnVarCleanFromInput('default_size','allow_local_only','use_buffering','use_compression','no_user_entry','security','reg_user_only','open_direct','use_fixed_title','auto_resize','vsize');
		
		// Admin functions of this type can be called by other modules.  If this
		// happens then the calling module will be able to pass in arguments to
		// this function through the $args parameter.  Hence we extract these
	  	// arguments *after* we have obtained any form-based input through
		// pnVarCleanFromInput().
		extract($var);
		
		//Save Settings
		pnModSetVar('PostWrap', 'default_size', $default_size);
		pnModSetVar('PostWrap', 'allow_local_only', $allow_local_only);
		pnModSetVar('PostWrap', 'use_buffering', $use_buffering);
		pnModSetVar('PostWrap', 'use_compression', $use_compression);
		pnModSetVar('PostWrap', 'no_user_entry', $no_user_entry);
		
		pnModSetVar('PostWrap', 'security', $security);
		
		pnModSetVar('PostWrap', 'reg_user_only', $reg_user_only);
		pnModSetVar('PostWrap', 'open_direct', $open_direct);
		pnModSetVar('PostWrap', 'use_fixed_title', $use_fixed_title);
		pnModSetVar('PostWrap', 'auto_resize', $auto_resize);
		pnModSetVar('PostWrap', 'vsize', $vsize);
		//Set Status
		pnSessionSetVar('PostWrap_status', _SETTINGSSAVED);
		pnRedirect(pnModURL('PostWrap', 'admin', 'Settings'));
		
		return true;
		return $output->GetOutput();
	}

function PostWrap_adminapi_updateUrlSettings($var)
	{
		$output = new pnHTML();
		// Security check - important to do this as early as possible to avoid
		// potential security holes or just too much wasted processing
		if (!pnSecAuthAction(0, 'PostWrap::', '::', ACCESS_ADMIN))
		{
			$output->Text(_MODIFYLINKSSNOAUTH);
			return $output->GetOutput();
		}
		
		list($reg_user_only, $open_direct, $use_fixed_title, $auto_resize, $vsize) = pnVarCleanFromInput('reg_user_only','open_direct','use_fixed_title','auto_resize','vsize');
		// Admin functions of this type can be called by other modules.  If this
		// happens then the calling module will be able to pass in arguments to
		// this function through the $args parameter.  Hence we extract these
	  	// arguments *after* we have obtained any form-based input through
		// pnVarCleanFromInput().
		extract($var);
		
		//Save Settings
		pnModSetVar('PostWrap', 'reg_user_only', $reg_user_only);
		pnModSetVar('PostWrap', 'open_direct', $open_direct);
		pnModSetVar('PostWrap', 'use_fixed_title', $use_fixed_title);
		pnModSetVar('PostWrap', 'auto_resize', $auto_resize);
		pnModSetVar('PostWrap', 'vsize', $vsize);
		//Set Status
		pnSessionSetVar('PostWrap_status', _SETTINGSSAVED);
		pnRedirect(pnModURL('PostWrap', 'admin', 'UrlSettings'));
		
		return true;
		return $output->GetOutput();
	}

//Add an Url
function PostWrap_adminapi_AddUrl($args)
{
	$output = new pnHTML();
	// Security check - important to do this as early as possible to avoid
	// potential security holes or just too much wasted processing
	if (!pnSecAuthAction(0, 'PostWrap::', '::', ACCESS_ADMIN))
	{
		$output->Text(_MODIFYLINKSSNOAUTH);
		return $output->GetOutput();
	}
	
	// Get parameters from whatever input we need.  All arguments to this
	// function should be obtained from pnVarCleanFromInput(), getting them
	// from other places such as the environment is not allowed, as that makes
	// assumptions that will not hold in future versions of PostNuke
	list($reg_user_only, $open_direct, $use_fixed_title, $auto_resize, $vsize, $host, $alias, $id) = pnVarCleanFromInput('reg_user_only','open_direct','use_fixed_title','auto_resize','vsize','host', 'alias', 'id');
	
	// Admin functions of this type can be called by other modules.  If this
	// happens then the calling module will be able to pass in arguments to
	// this function through the $args parameter.  Hence we extract these
  	// arguments *after* we have obtained any form-based input through
	// pnVarCleanFromInput().
	extract($args);
	
	$output->SetOutputMode(_PNH_KEEPOUTPUT);
	
	// Confirm authorisation code.  This checks that the form had a valid
	// authorisation code attached to it.  If it did not then the function will
	// proceed no further as it is possible that this is an attempt at sending
	// in false data to the system
	if (!pnSecConfirmAuthKey())
	{
		pnSessionSetVar('errormsg', _BADAUTHKEY);
		pnRedirect(pnModURL('PostWrap', 'admin', 'main'));
		return true;
	}
	
	if($host!=""&&$alias!="")
	{
		//Sanitize Url
		//To do: more complex checking
		$host_arr = parse_url($host);
		
		//Get rid of whitespaces
		$alias = str_replace(" ", "_", $alias);
		
		if(is_array($host_arr))
		{
			$host = "";
			if(empty($host_arr['scheme'])) $host = "http://";
			else $host = $host_arr['scheme'] . "://";
			
			if(!empty($host_arr['host'])) $host .= $host_arr['host'];
			if(!empty($host_arr['port'])) $host .= ":" . $host_arr['port'];
			if(!empty($host_arr['path'])) $host .= "" . $host_arr['path'];
			if(!empty($host_arr['query'])) $host .= "?" . $host_arr['query'];
			
			$output->Text($host_arr['scheme']."|");
			$output->Text($host_arr['host']);
			$output->Text($host_arr['port']);
			$output->Text($host_arr['path']);
			$output->Text($host_arr['query']);
			$output->LineBreak(4);
		}
		else
		{
			$output->Text(_BADURL);
			return false;
		}
		
		list($dbconn) = pnDBGetConn();
		$pntable = pnDBGetTables();
		
		$urltable = $pntable['postwrap_url'];
		
		//Check If this URL or Alias allready exists in DB if we don't edit them
		if (pnSessionGetVar('PostWrap_status') != _URLEDIT)
		{
			pnSessionSetVar('PostWrap_status','');
			
			$result = $dbconn->Execute("SELECT * FROM $urltable");
			
			while(list($id, $name_db, $alias_db) = $result->fields)
			{
				$result->MoveNext();
				if ($alias == $alias_db)
				{
			        pnSessionSetVar('errormsg', _DBERROREXISTSALIAS);
					pnRedirect(pnModURL('PostWrap', 'admin', 'Url'));
			        return false;
				}
				elseif ($host == $name_db)
				{
			        pnSessionSetVar('errormsg', _DBERROREXISTSHOST);
					pnRedirect(pnModURL('PostWrap', 'admin', 'Url'));
			        return false;
				}
			}
		}
		
		pnSessionSetVar('PostWrap_status','');
		
		if($id=="")
		{
			$sql = "INSERT
					INTO $urltable
					(name, alias, reg_user_only, open_direct, use_fixed_title, auto_resize, vsize)
					VALUES ('".pnVarPrepForStore($host)."',
							'".pnVarPrepForStore($alias)."',
							'".pnVarPrepForStore($reg_user_only)."',
							'".pnVarPrepForStore($open_direct)."',
							'".pnVarPrepForStore($use_fixed_title)."',
							'".pnVarPrepForStore($auto_resize)."',
							'".pnVarPrepForStore($vsize)."')";
		}
		else
		{
			$sql = "UPDATE
					$urltable
					SET name 			= '".pnVarPrepForStore($host)."',
						alias 			= '".pnVarPrepForStore($alias)."',
						reg_user_only 	= '".pnVarPrepForStore($reg_user_only)."',
						open_direct 	= '".pnVarPrepForStore($open_direct)."',
						use_fixed_title = '".pnVarPrepForStore($use_fixed_title)."',
						auto_resize 	= '".pnVarPrepForStore($auto_resize)."',
						vsize 			= '".pnVarPrepForStore($vsize)."'
					WHERE id=$id";
		}
		$result=$dbconn->Execute($sql);
		
	    // Check for an error with the database code, and if so set an
	    // appropriate error message and return
	    if ($dbconn->ErrorNo() != 0) {
	        pnSessionSetVar('errormsg', _DBERROR);
	        return false;
	    }
		if($id=="")
		{
			pnSessionSetVar('PostWrap_status', _URLSAVED);
		}
		else
		{
			pnSessionSetVar('PostWrap_status', _URLUPDATED);
		}
		
		pnRedirect(pnModURL('PostWrap', 'admin', 'Url'));
		
		return true;
	}
	else
	{
		$output->Text(_FILLFIELDS);
		return $output->GetOutput();
		
		return false;
	}
	return $output->GetOutput();
}


// Edit a Url
function PostWrap_adminapi_EditUrl($args)
{
	$output = new pnHTML();
	// Security check - important to do this as early as possible to avoid
	// potential security holes or just too much wasted processing
	if (!pnSecAuthAction(0, 'PostWrap::', '::', ACCESS_ADMIN))
	{
		$output->Text(_MODIFYLINKSSNOAUTH);
		return $output->GetOutput();
	}
	/*
	// Confirm authorisation code.  This checks that the form had a valid
	// authorisation code attached to it.  If it did not then the function will
	// proceed no further as it is possible that this is an attempt at sending
	// in false data to the system
	if (!pnSecConfirmAuthKey())
	{
		pnSessionSetVar('errormsg', _BADAUTHKEY);
		pnRedirect(pnModURL('PostWrap', 'admin', 'main'));
		return true;
	}
	*/
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();
	
	list($id)= pnVarCleanFromInput('id');
	extract($args); 
	
	$urltable = $pntable['postwrap_url'];
	
	// extract info from db
	$sql = "SELECT
			*
			FROM
			$urltable
			WHERE id=$id";
	
	$result = $dbconn->Execute($sql);
	$output->FormStart(pnModURL('PostWrap', 'adminapi', 'AddUrl'));
	// Add an authorisation ID - this adds a hidden field in the form that
	// contains an authorisation ID.  The authorisation ID is very important in
	// preventing certain attacks on the website
	$output->FormHidden('authid', pnSecGenAuthKey());
	
	$output->TableStart('','',0);
	
	$row1 = array();
	$output->SetOutputMode(_PNH_RETURNOUTPUT);
	
	//$row1[] = $output->BoldText(_IDURL);
	$row1[] = $output->BoldText(_URLNAME);
	$row1[] = $output->BoldText(_URLALIAS);
	
	$output->SetOutputMode(_PNH_KEEPOUTPUT);
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	
	$output->TableAddRow($row1, 'left');
	
	$row3 = array();
	$output->SetOutputMode(_PNH_RETURNOUTPUT);
	
	list($id, $host, $alias, $reg_user_only, $open_direct, $use_fixed_title, $auto_resize, $vsize) = $result->fields;
	
	//$row3[] = $output->Text($id).$output->FormHidden('id', $id);
	
	$row3[] = $output->FormText('host', $host, 30, 255).$output->FormHidden('id', $id);;
	$row3[] = $output->FormText('alias', $alias, 30, 50);
	$row3[] = $output->FormSubmit(_URLSAVE);
	$output->SetOutputMode(_PNH_KEEPOUTPUT);
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	$output->TableAddRow($row3, 'left');
	//$output->Linebreak(2);
	
	$output->TableEnd();
	
	//Set some values if they exists
	if (isset($reg_user_only))
	{
		$reg_user_only_db['0'] = '';
		$reg_user_only_db['1'] = '';
		$reg_user_only_db[$reg_user_only] = ' checked';
	}
	if (isset($open_direct))
	{
		$open_direct_db['0'] = '';
		$open_direct_db['1'] = '';
		$open_direct_db[$open_direct] = ' checked';
	}
	if (isset($use_fixed_title))
	{
		$use_fixed_title_db['0'] = '';
		$use_fixed_title_db['1'] = '';
		$use_fixed_title_db[$use_fixed_title] = ' checked';
	}
	if (isset($auto_resize))
	{
		$auto_resize_db['0'] = '';
		$auto_resize_db['1'] = '';
		$auto_resize_db[$auto_resize] = ' checked';
	}
	//End set
	$output->Linebreak();
	$output->BoldText(_ADMINURLOVERRIDE._ADMINCONFIG._ADMINURLOVERRIDE1);
	$output->Linebreak(2);
	
	$output->SetInputMode(_PNH_VERBATIMINPUT);
	
	$output->Text(_REGUSERONLY);
	$output->FormCheckbox('reg_user_only', $reg_user_only_db['0'], '0', 'radio');
	$output->Text(_NO);
	$output->FormCheckbox('reg_user_only', $reg_user_only_db['1'], '1', 'radio');
	$output->Text(_YES);
	$output->Linebreak();
	$output->Text(_OPENDIRECT);
	$output->FormCheckbox('open_direct', $open_direct_db['0'], '0', 'radio');
	$output->Text(_NO);
	$output->FormCheckbox('open_direct', $open_direct_db['1'], '1', 'radio');
	$output->Text(_YES);
	$output->Linebreak();
	$output->Text(_USEFIXEDTITLE);
	$output->FormCheckbox('use_fixed_title', $use_fixed_title_db['0'], '0', 'radio');
	$output->Text(_NO);
	$output->FormCheckbox('use_fixed_title', $use_fixed_title_db['1'], '1', 'radio');
	$output->Text(_YES);
	$output->Linebreak(2);
	$output->Text(_AUTORESIZE);
	$output->FormCheckbox('auto_resize', $auto_resize_db['0'], '0', 'radio');
	$output->Text(_NO);
	$output->FormCheckbox('auto_resize', $auto_resize_db['1'], '1', 'radio');
	$output->Text(_YES);
	$output->Linebreak();
	$output->Text(_VSIZE);
	$output->FormText('vsize', $vsize, 4, 4);
	$output->Linebreak(2);
	$output->Text(_VSIZENOTE1);
	$output->Text(", ");
	$output->Text(_VSIZENOTE2);
	$output->SetOutputMode(_PNH_RETURNOUTPUT);
	
	$output->FormEnd();
	
	pnSessionSetVar('PostWrap_status', _URLEDIT);
	
	return $output->GetOutput();
}

// delete a Url
function PostWrap_adminapi_deleteUrl($args)
{
	// Security check - important to do this as early as possible to avoid
	// potential security holes or just too much wasted processing
	if (!pnSecAuthAction(0, 'PostWrap::', '::', ACCESS_ADMIN))
	{
		$output->Text(_MODIFYLINKSSNOAUTH);
		return $output->GetOutput();
	}
	/*
	// Confirm authorisation code.  This checks that the form had a valid
	// authorisation code attached to it.  If it did not then the function will
	// proceed no further as it is possible that this is an attempt at sending
	// in false data to the system
	if (!pnSecConfirmAuthKey())
	{
		pnSessionSetVar('errormsg', _BADAUTHKEY);
		pnRedirect(pnModURL('PostWrap', 'admin', 'main'));
		return true;
	}
	*/
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();
	
	list($id)= pnVarCleanFromInput('id');
	extract($args); 
	
	$urltable = $pntable['postwrap_url'];
	
	// extract info from db
	$sql = "DELETE
			FROM
			$urltable
			WHERE id=$id";
	
	$result = $dbconn->Execute($sql);
	
    if ($dbconn->ErrorNo() != 0)
	{
        pnSessionSetVar('errormsg', _DBDELETEERROR);
        return false;
    }
		pnSessionSetVar('PostWrap_status', _URLDELETED);
		pnRedirect(pnModURL('PostWrap', 'admin', 'Url'));
		return true;
}
?>